#!/bin/sh

set -e

TCCVER=0.9.24

echo "========================"
echo "Cleanup before build ..."
echo "========================"
make -f Makefile.mingw-cross clean

echo "==================="
echo "Building TinyCC ..."
echo "==================="
( cd tcc ; sh mingw-cross-build.sh )
# copy SQLite headers into TCC install include directory
# cp -p sqlite/sqlite.h TCC/include
# copy LGPL to TCC install doc directory
cp -p tcc-${TCCVER}/COPYING TCC/doc

echo "==============================="
echo "Building ODBC drivers and utils"
echo "==============================="
make -f Makefile.mingw-cross

echo "============================"
echo "Building DLL import defs ..."
echo "============================"
# requires wine: create .def files with tiny_impdef.exe
# for all .dll files which provide SQLite
wine TCC/tiny_impdef.exe hakamaodbc.dll -o TCC/lib/hakama.def

echo "==========================="
echo "Creating NSIS installer ..."
echo "==========================="
cp -p README readme.txt
#unix2dos < license.terms > license.txt
nkf -todos < license.terms > license.txt
#unix2dos -k TCC/doc/COPYING
#unix2dos -k TCC/doc/readme.txt
makensis $ADD_NSIS hakamaodbc.nsi

