/*
 * libmondai -- MONTSUQI data access library
 * Copyright (C) 2002-2003 Ogochan & JMA (Japan Medical Association).
 * Copyright (C) 2004-2009 Ogochan
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	_INC_COMPILE_H
#define	_INC_COMPILE_H
#include	"hakama.h"

#define	SQL_TYPE_NULL		0
#define	SQL_TYPE_SELECT		1
#define	SQL_TYPE_RECORD		2
#define	SQL_TYPE_UPDATE		3
#define	SQL_TYPE_INSERT		4
#define	SQL_TYPE_DELETE		5

#define	ITEM_TYPE_NULL			0x00

#define	ITEM_TYPE_NUMERIC		0x10
#define	ITEM_TYPE_INT			0x11
#define	ITEM_TYPE_BOOL			0x12
#define	ITEM_TYPE_FLOAT			0x13
#define	ITEM_TYPE_NUMBER		0x14

#define	ITEM_TYPE_STRING		0x20
#define	ITEM_TYPE_CHAR			0x21
#define	ITEM_TYPE_TEXT			0x22
#define	ITEM_TYPE_VARCHAR		0x23
#define	ITEM_TYPE_DBCODE		0x24

#define	ITEM_TYPE_BYTE			0x31
#define	ITEM_TYPE_BINARY		0x32

#define	ITEM_TYPE_OBJECT		0x40

#define	ITEM_TYPE_TIMESTAMP		0x50
#define	ITEM_TYPE_DATE			0x51
#define	ITEM_TYPE_TIME			0x52

#define	ITEM_TYPE_ARRAY			0x81
#define	ITEM_TYPE_RECORD		0x82



extern	void		CompileInit(void);
extern	SqlInfo		*CompileSQL(char *sql);
extern	ItemStruct	*CompileRecord(char *code);
extern	void		DumpItemStruct(ItemStruct *item);
extern	void		DestroyItemStruct(ItemStruct *items);
extern	void		DestroySqlInfo(SqlInfo *info);


#endif
