#!/bin/sh

set -e

if test -n "$SQLITE_DLLS" ; then
    export ADD_CFLAGS="-DWITHOUT_SHELL=1 -DWITH_SQLITE_DLLS=1"
    ADD_NSIS="-DWITH_SQLITE_DLLS"
fi

if test -n "$WITH_SOURCES" ; then
    ADD_NSIS="$ADD_NSIS -DWITH_SOURCES"
fi

TCCVER=0.9.24

echo "========================"
echo "Cleanup before build ..."
echo "========================"
make -f Makefile.mingw-cross clean

echo "==============================="
echo "Building ODBC drivers and utils"
echo "==============================="
make -f Makefile.mingw-cross

echo "============================"
echo "Building DLL import defs ..."
echo "============================"
# requires wine: create .def files with tiny_impdef.exe
# for all .dll files which provide SQLite
#wine TCC/tiny_impdef.exe hakamaodbc.dll -o TCC/lib/hakama.def

echo "==========================="
echo "Creating NSIS installer ..."
echo "==========================="
cp -p README readme.txt
unix2dos < license.terms > license.txt
#unix2dos -k TCC/doc/COPYING
#unix2dos -k TCC/doc/readme.txt
makensis $ADD_NSIS hakamaodbc.nsi

