#ifndef	_INC_HAKAMA
#define	_INC_HAKAMA

#if defined(_WIN32) || defined(_WIN64)
#include	<windows.h>
#include	<winsock2.h>
#include	<process.h>
#else
#include	<sys/time.h>
#include	<sys/types.h>
#include	<stdio.h>
#include	<unistd.h>
#define		SOCKET		int
#endif

#include	"libs.h"
//#include        "compile.h"
#define	SIZE_SERVER		1024
#define	SIZE_PORT		16
#define	SIZE_USER		255
#define	SIZE_PASSWORD	        255
#define	SIZE_ENCODING	        255
#define	SIZE_CHECKBOX	        255



typedef	struct {
	char	*name;
	char	*data;
}	HakamaKeyValue;

typedef	struct {
	int				count;
	GHashTable		*item;
	HakamaKeyValue	**vals;
}	HakamaRecord;

typedef	struct {
	int				count;
	HakamaRecord	**rec;
}	HakamaRecords;

typedef	struct {
	int				count;
	char			**item;
}	HakamaList;

typedef	struct _ItemStruct	{
	int		type;
	union {
		struct {
			size_t				count;
			struct	_ItemStruct	*item;
		}	ArrayData;
		struct {
			size_t				count;
			struct	_ItemStruct	**item;
			char				**names;
			GHashTable			*members;
		}	RecordData;
		struct {
			size_t				length;
		}	CharData;
		struct {
			size_t				length;
			size_t				slength;
		}	NumberData;
	}	body;
}	ItemStruct;

typedef struct	{
	int		n;
	char	**name;
}	Fields;


typedef struct	{
	int		type;
	char	*tname;
	char	*rname;
	char	*pname;
	HakamaRecord	*rec;
	Fields	        *fields;
	ItemStruct	*record;
	int		limit;
	int		offset;
}	SqlInfo;

typedef struct {
  char *from;
  char *to;
} HakamaConvMode;

typedef	struct {
	SOCKET	sd;
	int	count;
	int	version;
        int isselect;
        int lastrc;
        SqlInfo *info;
        HakamaConvMode input_enc;
        HakamaConvMode output_enc;  
}	Hakama;



extern	Hakama	*HakamaConnect(char *host, char *port, char *user, char *pass);
extern	int		HakamaExec(Hakama *hakama, char *func);
extern	HakamaRecord	*HakamaNewRecord(void);
extern	HakamaRecords	*HakamaNewRecords(void);
extern	void	HakamaEnterValue(HakamaRecord *rec, char *name, char *value);
extern	void	HakamaDumpRecord(HakamaRecord *rec);
extern	HakamaRecords	*HakamaExecRecord(Hakama *hakama, char *func,
										  char *rname, char *pname, char *rename,
										  HakamaRecord *rec, int limit);
extern	HakamaRecords	*HakamaExecSql(Hakama *hakama, char *sql, int *compile_error);
extern	HakamaList		*HakamaGetPathTables(Hakama *hakama, char *table);
extern	HakamaRecords	*HakamaGetPathSchema(Hakama *hakama, char *name);

extern	void	HakamaDestroyRecord(HakamaRecord *rec);
extern	void	HakamaDestroyRecords(HakamaRecords *recs);
extern	void	HakamaDestroyList(HakamaList *list);

extern	void	HakamaDumpRecords(HakamaRecords *recs);

extern	void	HakamaDisconnect(Hakama **hakama);
extern	char	*HakamaGetValue(HakamaRecord *rec, char *name);
extern	void    HakamaMergeRecord(HakamaRecord *dest, HakamaRecord *src, int overwrite);
extern	void ConvertRecord(HakamaRecords *recs,	ItemStruct *item);


extern void
HakamaConvCharset(HakamaConvMode mode, char *outbuf, int outbytes, char *inbuf);

extern HakamaConvMode
HakamaGetInputConvMode(void);

extern HakamaConvMode
HakamaGetOutputConvMode(void);

extern void
HakamaSetOutputConvMode(HakamaConvMode mode);

extern void
HakamaSetInputConvMode(HakamaConvMode mode);

extern	void
HakamaEnterValueWithCharset(
	HakamaConvMode          convmode,			    
	HakamaRecord		*rec,
	char			*name,
	char			*value);
extern void
HakamaConvCharsetRecord(HakamaConvMode convmode, HakamaRecord *rec);

extern void
DestroyFields(Fields *fields);


#endif
