#define	DEBUG
#define	TRACE
#define	CONSOLE_DEBUG

/*
*/
#define	TEST_PRINTF
#define	TEST_QUERY_PATH
#define	TEST_PATHSCHEMA
#define	TEST_PATHTABLES
#define	TEST_QUERY_SQL
#define	TEST_RECORD_COMPILE
#define	TEST_RECORD_CONVERT
#define	TEST_SQL_COMPILE


#define DBS_HOST "localhost"
#define DBS_PORT "8013"

#include	"socket.h"
#include	"hakama.h"
#include	"libs.h"
#include	"compile.h"
#include	"printf.h"
#include	"debug.h"
#include	<stdio.h>

#if	1
extern	int		PASCAL
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPSTR		lpszCmdLine,
	int			nCmdShow)
{
	WSADATA			wsaData;
	Hakama			*hakama;
	HakamaRecord	*test1;
	HakamaRecords	*rec;
	HakamaList		*list;
	int				i;
	int compile_error;

ENTER_FUNC;
	WSAStartup(MAKEWORD(2,0), &wsaData);
#ifdef	TEST_PRINTF
	{
		char		*p;
		p = hakama_mprintf("[%d][%s][%q]",100,"ogochan\'s","ogochan\'s");
		printf("%s",p);
		xfree(p);
	}
#endif
#ifdef	TEST_RECORD_COMPILE
	CompileInit();
	CompileSQL(
		"test1{id varchar(40);class varchar(20);code int;};"
		);
	CompileSQL(
"test1	{"
"	id		varchar(40);"
"	class	varchar(20);"
"	code	int;"
"	foo {"
"		baa int;"
"	}	[10];"
"};"
		);
#endif
#ifdef	TEST_RECORD_CONVERT
	{
		HakamaRecords	*recs;
		ItemStruct	*items;

		CompileInit();
		items = CompileRecord(
			"test1{id varchar(40);class varchar(20);code int;};"
			);
		recs = HakamaNewRecords();
		ConvertRecord(recs,items);
		DestroyItemStruct(items);
		HakamaDumpRecords(recs);
		HakamaDestroyRecords(recs);
		items = CompileRecord(
"test1	{"
"	id		varchar(40);"
"	class	varchar(20);"
"	code	int;"
"	foo {"
"		baa int;"
"	}	[10];"
"};"
			);
		recs = HakamaNewRecords();
		ConvertRecord(recs,items);
		DestroyItemStruct(items);
		HakamaDumpRecords(recs);
		HakamaDestroyRecords(recs);
	}
#endif
#ifdef	TEST_SQL_COMPILE
	CompileInit();
	CompileSQL("INSERT INTO test1 (id, class, code) values('111111', '222222', 999997);");
	//CompileSQL("INSERT INTO test1 (99999, '999999', '99999');");
	/*
	CompileSQL(
		"UPDATE test1 SET code=2,id2=3 WHERE id=\"aa\";"
		);
	CompileSQL(
		"UPDATE test1 SET test1.code=\"test\" WHERE id = 1;"
		);
	CompileSQL(
		"ISERT INTO test1 (id, code) VALUES(1, 2);"
		);
	CompileSQL(
		"ISERT INTO test1 (1, 2);"
		);
	CompileSQL(
		"DELETE FROM test1;"
		);
	CompileSQL(
		"DELETE FROM test1 where code=1;"
		);
	CompileSQL(
		"SELECT \"test2$id\".id, \"test2$id\".class, \"test2$id\".code"
		" FROM public.\"test2$id\" \"test2$id\""
		" WHERE (\"test2$id\".code = 2 ) LIMIT 5;"
		);
	CompileSQL(
		"SELECT id, class, code"
		" FROM test2"
		" WHERE ( code = 2 ) LIMIT 3;"
		);
	CompileSQL(
		"SELECT \"test1$id3_0\".id, \"test1$id3_0\".class, \"test1$id3_0\".code"
		" FROM public.\"test1$id3\" \"test1$id3_0\""
		);
	*/
#endif
#ifdef	TEST_QUERY_PATH
	if		(  ( hakama = HakamaConnect(DBS_HOST,DBS_PORT,"test","test") )
			   !=  NULL  ) {
		dbgmsg("Connect");
	} else {
		dbgmsg("fail");
	}
	printf("DBOPEN       rc = %d\n",HakamaExec(hakama,"DBOPEN"));
	printf("DBSTART      rc = %d\n",HakamaExec(hakama,"DBSTART"));
	
	test1 = HakamaNewRecord();
	HakamaEnterValue(test1,"test.code","10");
#if	0
	HakamaDestroyRecords(HakamaExecRecord(hakama,"DBSELECT","test1","id2",test1,1));
	while	(	(  ( rec = HakamaExecRecord(hakama,"DBFETCH","test1","id2",test1,1) )
				   !=  NULL  )
			&&	(  rec->count  ==  1  ) ) {
		HakamaDumpRecord(rec->rec[0]);
		HakamaDestroyRecords(rec);
	}
	HakamaDestroyRecords(HakamaExecRecord(hakama,"DBCLOSECURSOR","test1","id2",NULL,1));
#endif
	rec = HakamaExecRecord(hakama,"DBSELECT","test1","id3",NULL,test1,10000);
	for	( i = 0 ; i < hakama->count ; i ++ ) {
		HakamaDumpRecord(rec->rec[i]);
	}
	HakamaDestroyRecords(rec);

	printf("DBCOMMIT     rc = %d\n",HakamaExec(hakama,"DBCOMMIT"));
	HakamaDisconnect(&hakama);
	//printf("DBDISCONNECT rc = %d\n",HakamaExec(hakama,"DBDISCONNECT"));
#endif
#ifdef	TEST_QUERY_SQL
	if		(  ( hakama = HakamaConnect(DBS_HOST,DBS_PORT,"test","test") )  !=  NULL  ) {
		dbgmsg("Connect");
	} else {
		dbgmsg("fail");
	}
	printf("DBOPEN       rc = %d\n",HakamaExec(hakama,"DBOPEN"));
	printf("DBSTART      rc = %d\n",HakamaExec(hakama,"DBSTART"));
	
	//rec = HakamaExecSql(hakama,"SELECT * FROM test1$id3 WHERE ( code = 10 ) LIMIT 5");
	rec = HakamaExecSql(hakama,
"SELECT \"test1$id3\".id, \"test1$id3\".class, \"test1$id3\".code "
"FROM public.\"test1$id3\" \"test1$id3\" "
"WHERE (\"test1$id3\".code=10)"
			    ,&compile_error);
	if		(  rec  !=  NULL  ) {
		for	( i = 0 ; i < rec->count ; i ++ ) {
			HakamaDumpRecord(rec->rec[i]);
		}
		HakamaDestroyRecords(rec);
	}

	printf("DBCOMMIT     rc = %d\n",HakamaExec(hakama,"DBCOMMIT"));
	HakamaDisconnect(&hakama);
	//printf("DBDISCONNECT rc = %d\n",HakamaExec(hakama,"DBDISCONNECT"));
#endif
#ifdef	TEST_PATHTABLES
	if		(  ( hakama = HakamaConnect(DBS_HOST,DBS_PORT,"test","test") )  !=  NULL  ) {
		dbgmsg("Connect");
	} else {
		dbgmsg("fail");
	}
	printf("DBOPEN       rc = %d\n",HakamaExec(hakama,"DBOPEN"));
	printf("DBSTART      rc = %d\n",HakamaExec(hakama,"DBSTART"));

	list = HakamaGetPathTables(hakama,NULL);
	for	( i = 0 ; i < list->count ; i ++ ) {
		printf("%s\n",list->item[i]);
	}
	HakamaDestroyList(list);
	printf("\n---\n");
	list = HakamaGetPathTables(hakama,"test1");
	for	( i = 0 ; i < list->count ; i ++ ) {
		printf("%s\n",list->item[i]);
	}
	printf("\n---\n");
	list = HakamaGetPathTables(hakama,"test1$id3");
	if		(  list  !=  NULL  )	{
		for	( i = 0 ; i < list->count ; i ++ ) {
			printf("%s\n",list->item[i]);
		}
	}
	HakamaDestroyList(list);

	printf("DBCOMMIT     rc = %d\n",HakamaExec(hakama,"DBCOMMIT"));
	HakamaDisconnect(&hakama);
	//printf("DBDISCONNECT rc = %d\n",HakamaExec(hakama,"DBDISCONNECT"));
#endif
#ifdef	TEST_PATHSCHEMA
	if		(  ( hakama = HakamaConnect(DBS_HOST,DBS_PORT,"test","test") )  !=  NULL  ) {
		dbgmsg("Connect");
	} else {
		dbgmsg("fail");
	}
	printf("DBOPEN       rc = %d\n",HakamaExec(hakama,"DBOPEN"));
	printf("DBSTART      rc = %d\n",HakamaExec(hakama,"DBSTART"));

	rec = HakamaGetPathSchema(hakama,"test1$id3");
	if		(  rec  !=  NULL  ) {
		for	( i = 0 ; i < rec->count ; i ++ ) {
			HakamaDumpRecord(rec->rec[i]);
		}
		HakamaDestroyRecords(rec);
	}

	printf("DBCOMMIT     rc = %d\n",HakamaExec(hakama,"DBCOMMIT"));
	HakamaDisconnect(&hakama);
	//printf("DBDISCONNECT rc = %d\n",HakamaExec(hakama,"DBDISCONNECT"));
#endif
LEAVE_FUNC;
	WSACleanup();
	MessageBox(NULL,"finish...","test",MB_OK);
	return	0;
}
#else
extern	int
main(void)
{

}
#endif
