/*
 * libmondai -- MONTSUQI data access library
 * Copyright (C) 2002-2003 Ogochan & JMA (Japan Medical Association).
 * Copyright (C) 2004-2009 Ogochan
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	_INC_LEX_H
#define	_INC_LEX_H

#define	YYBASE			256
#define	T_EOF			(YYBASE +1)
#define	T_SYMBOL		(YYBASE +2)
#define	T_SCONST		(YYBASE +3)
#define	T_STRING		T_SCONST
#define	T_ICONST		(YYBASE +4)
#define	T_NCONST		(YYBASE +5)
#define	T_RCONST		(YYBASE +6)

#define	T_LT			'<'
#define	T_LE			(YYBASE +10)
#define	T_EQ			'='
#define	T_GE			(YYBASE +12)
#define	T_GT			'>'
#define	T_NE			(YYBASE +14)

#define	T_YYBASE		(YYBASE +20)

typedef	struct	{
	char	*str;
	int		token;
}	TokenTable;

typedef	struct {
	char	*body;
	int		back;
	size_t	pos;
	size_t	size;
	int		cLine;
	Bool	fError;
	char	*Symbol;
	int		Int;
	int		Token;
	GHashTable	*reserved;
}	CURFILE;

extern	int				Lex(CURFILE *in, int type);
extern	GHashTable		*LexInit(TokenTable *tokentable);

#define	GetSymbol		(ComToken = Lex(in,FALSE))
#define	GetName			(ComToken = Lex(in,TRUE))
#define	ComToken		(in->Token)
#define	ComInt			(in->Int)
#define	ComSymbol		(in->Symbol)

#endif
